# -*- coding: utf-8 -*-
from setuphelpers import *

dst_dir = '/opt/upsync'
dst_bin = makepath(dst_dir,'upsync')

def install():
    
    if type_debian():
        filecopyto('ms-auth.crt', makepath('/usr','local','share','ca-certificates'))
        print(run('update-ca-certificates -f'))
        install_apt('cabextract')
    else:
        filecopyto('ms-auth.crt', makepath('/etc','pki','ca-trust','source','anchors'))
        print(run('update-ca-trust'))
        install_yum('cabextract')

    if not isdir(dst_dir):
        mkdirs(dst_dir)
    if isfile(dst_bin):
        remove_file(dst_bin)
    filecopyto('upsync',dst_bin)
    run('chmod a+x %s' % dst_bin)

def audit():
    if isfile(dst_bin):
        return 'OK'
    else:
        return "ERROR"

def uninstall():
    remove_tree(dst_dir)
